/*
 *	adsbox - ADS-B decoder software
 *	(c) atty 2011-13 romulmsg@mail.ru
 *
 */
#include <stdio.h>
#include <time.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <string.h>
#include <stdlib.h>
#include "file.h"
#include "misc.h"

extern char grawdata[BUFLEN];

float sec_between(struct timespec now, struct timespec then) {
	float result;
	result = now.tv_sec - then.tv_sec + (now.tv_nsec - then.tv_nsec)
			/ 1000000000.;
	return (result);
}

void *player_thread(void *arg) {
	file_info *fi = (file_info *)arg;
	FILE * rd;
	unsigned char rawbuf[BUFLEN];
	struct tm tm;
	int r;
	struct timespec ts_now, ts_prev;
	struct timespec fts_now, fts_prev;
	static int msqid;	
	struct msgbuf sndbuf, *msgp;

	if ((rd = fopen(fi->name, "r")) == NULL) {
			DEBUG("Unable to open %s\n", fi->name);
			free(fi);
			pthread_exit(0);
	}

	msqid = msgget(msqkey, 0666 | IPC_CREAT);
	msgp = &sndbuf;
	msgp->mtype = 1;
	
	for (r = 0; r < fi->delay; r++) sleep(1);

	bzero(rawbuf, BUFLEN);
	r = fscanf(rd, "%u:%u:%u.%u %u.%u.%u %s\n", &tm.tm_hour, &tm.tm_min,
			&tm.tm_sec, &fts_prev.tv_nsec, &tm.tm_mday, &tm.tm_mon,
			&tm.tm_year, &rawbuf);
	fts_prev.tv_sec = mktime(&tm);
	fts_prev.tv_nsec = fts_prev.tv_nsec * 1000000;

	while (r != EOF) {
		bzero(sndbuf.mtext, sizeof(sndbuf.mtext));
		sprintf(sndbuf.mtext, "%s", rawbuf);
		if (msgsnd(msqid, (const void *)msgp, sizeof(sndbuf.mtext), IPC_NOWAIT) == -1) {
			DEBUG("player_thread(): msgsend()\n");
			free(fi);
			pthread_exit(0);
		}

		bzero(grawdata, BUFLEN);
		memcpy(grawdata, sndbuf.mtext, strlen(sndbuf.mtext)); // raw data to seed

		bzero(rawbuf, BUFLEN);

		r = fscanf(rd, "%u:%u:%u.%u %u.%u.%u %s\n", &tm.tm_hour, &tm.tm_min,
				&tm.tm_sec, &fts_now.tv_nsec, &tm.tm_mday, &tm.tm_mon,
				&tm.tm_year, &rawbuf);
		fts_now.tv_sec = mktime(&tm);
		fts_now.tv_nsec = fts_now.tv_nsec * 1000000;

		clock_gettime(CLOCK_REALTIME, &ts_prev);
		while (sec_between(ts_now, ts_prev) * (double)fi->playrate < sec_between(fts_now,
				fts_prev)) {
			usleep(10000);
			clock_gettime(CLOCK_REALTIME, &ts_now);
		}
		fts_prev = fts_now;
	}

	free(fi);
	DEBUG("\nEOF Ctrl-C to exit.\n");
	pthread_exit(0);
}
