/*
 *	adsbox - ADS-B decoder software
 *	(c) atty 2011-13 romulmsg@mail.ru
 *
 */
#include <stdio.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include "tcpclient.h"
#include "misc.h"

void *tcp_client(void *arg) {		/* Data client thread */
    tcp_info *ti = (tcp_info*) arg;
    unsigned char rawbuf[BUFLEN];
    char data[2];
    static int msqid;
    struct msgbuf sndbuf, *msgp;
    struct sockaddr_in addr;
    int fd;

    fd = socket(AF_INET, SOCK_STREAM, 0);
    if (fd < 0)
        panic("socket");

    memset(&addr, 0, sizeof(addr));
    addr.sin_family = AF_INET;
    addr.sin_port = htons(ti->port);
    addr.sin_addr.s_addr = inet_addr(ti->addr);

    DEBUG("Connecting to AVR data server %s:%i...\n", ti->addr, ti->port);
    if (connect(fd, (struct sockaddr *) &addr, sizeof(addr)) < 0) {
        DEBUG("Could not connect to %s:%i\n",ti->addr,
              ti->port);
        free(ti);
        pthread_exit(0);
    }
    DEBUG("Connected to %s:%i\n",ti->addr,
          ti->port);

    msqid = msgget(msqkey, 0666 | IPC_CREAT);
    msgp = &sndbuf;
    msgp->mtype = 1;

    while(1) {
        bzero(rawbuf, BUFLEN)
        ;
        while (strstr(rawbuf, ";") == NULL) {
            read(fd, data, 1);
            if (data[0] == '*' || data[0] == '@')
                bzero(rawbuf, BUFLEN);
            strncat(rawbuf, data, 1);
        }
        bzero(sndbuf.mtext, sizeof(sndbuf.mtext));
        sprintf(sndbuf.mtext, "%s", rawbuf);
        if (msgsnd(msqid, (const void *)msgp, sizeof(sndbuf.mtext), IPC_NOWAIT) == -1)
            panic("msgsnd()");
    }
    free(ti);
    pthread_exit(0);
}
